class PureStake {
  /// The default API Token Header for PureStake nodes.
  static const API_TOKEN_HEADER = 'x-api-key';

  /// The Algod API url for PureStake's MainNet.
  static const MAINNET_ALGOD_API_URL =
      'https://mainnet-algorand.api.purestake.io/ps2';

  /// The Algod API url for PureStake's TestNet.
  static const TESTNET_ALGOD_API_URL =
      'https://testnet-algorand.api.purestake.io/ps2';

  /// The Algod API url for PureStake's BetaNet.
  static const BETANET_ALGOD_API_URL =
      'https://betanet-algorand.api.purestake.io/ps2';

  /// The Indexer API url for PureStake's MainNet.
  static const MAINNET_INDEXER_API_URL =
      'https://mainnet-algorand.api.purestake.io/idx2';

  /// The Indexer API url for PureStake's TestNet.
  static const TESTNET_INDEXER_API_URL =
      'https://testnet-algorand.api.purestake.io/idx2';

  /// The Indexer API url for PureStake's BetaNet.
  static const BETANET_INDEXER_API_URL =
      'https://betanet-algorand.api.purestake.io/idx2';
}

class AlgoExplorer {
  /// The Algod API url for AlgoExplorer's MainNet.
  static const MAINNET_ALGOD_API_URL = 'https://node.algoexplorerapi.io';

  /// The Algod API url for AlgoExplorer's TestNet.
  static const TESTNET_ALGOD_API_URL =
      'https://node.testnet.algoexplorerapi.io';

  /// The Algod API url for AlgoExplorer's BetaNet.
  static const BETANET_ALGOD_API_URL =
      'https://node.betanet.algoexplorerapi.io';

  /// The Indexer API url for AlgoExplorer's MainNet.
  static const MAINNET_INDEXER_API_URL =
      'https://algoindexer.algoexplorerapi.io';

  /// The Indexer API url for AlgoExplorer's TestNet.
  static const TESTNET_INDEXER_API_URL =
      'https://algoindexer.testnet.algoexplorerapi.io';

  /// The Indexer API url for AlgoExplorer's BetaNet.
  static const BETANET_INDEXER_API_URL =
      'https://algoindexer.betanet.algoexplorerapi.io';
}
